<?php

/*
 * PAYPAL SUBSCRIPTION MANAGER
 *
 * @package PaypalSubscriptionManager
 * @author  Michael J. Pawlowsky <mikep@mi-software.com>
 * @copyright Copyright &copy; 2005, Ultimate Internet Marketing
 * @version $Id: Config.class.php,v 1.2 2005/09/07 21:14:13 mikep Exp $;
 *
 * Created: Wed Sep 07 07:02:00 EDT 2005 07:02:00
 * Last Modified: $Date: 2005/09/07 21:14:13 $
 * Revision: $Rev:$
 *
 */

require_once('Db.class.php');

class TxnLog{


	var $log_id             = 0;
	var $user_id            = 0;
	var $txn_id             = '';
	var $payer_id           = '';
	var $subscr_id          = '';
	var $txn_type           = '';
	var $item_name          = '';
	var $item_number        = '';
	var $mc_gross           = 0.0;
	var $mc_fee             = 0.0;
	var $txn_date           = 0;
	var $username           = '';
	var $err_no             = 0;
	var $err_msg            = '';


	function TxnLog($id = 0){
		if($id > 0){
			$sql = new MySQL_class;
			$sql->Create();

			$qry = ' SELECT  * FROM tblTxnLog '. ' WHERE log_id = ' . $id;
			$row = $sql->QueryRow($qry);
			if($sql->err_no == 0){
				$this->log_id          = $row['log_id'];
				$this->user_id         = $row['user_id'];
				$this->txn_id          = $row['txn_id'];
				$this->payer_id        = $row['payer_id'];
				$this->subscr_id       = $row['subscr_id'];
				$this->txn_type        = $row['txn_type'];
				$this->item_name       = $row['item_name'];
				$this->item_number     = $row['item_number'];
				$this->mc_gross        = $row['mc_gross'];
				$this->mc_fee          = $row['mc_fee'];
				$this->txn_date        = $row['txn_date'];
			}else{
				$this->err_no  = $sql->err_no;
				$this->err_msg = $sql->err_msg;
			}
			return ($sql->err_no);
		}
		return (0);
	}


	function insertLog(){

		$sql = new MySQL_class;
		$sql->Create();

		$qry = 'INSERT INTO tblTxnLog ( '
		. ' user_id, '
		. ' txn_id, '
		. ' payer_id, '
		. ' subscr_id, '
		. ' txn_type, '
		. ' item_name, '
		. ' item_number, '
		. ' mc_gross, '
		. ' mc_fee, '
		. ' txn_date ) '
		.' VALUES ('
		. prepStr($this->user_id)       . ', '
		. prepStr($this->txn_id)        . ', '
		. prepStr($this->payer_id)      . ', '
		. prepStr($this->subscr_id)     . ', '
		. prepStr($this->txn_type)      . ', '
		. prepStr($this->item_name)     . ', '
		. prepStr($this->item_number)   . ', '
		. prepStr($this->mc_gross)      . ', '
		. prepStr($this->mc_fee)        . ', '
		. prepStr($this->txn_date)      . ')';
		$sql->Insert($qry);
		$this->log_id = $sql->lastid;
		if($sql->err_no != 0){
			$this->err_no = $sql->err_no;
			$this->err_msg = $sql->err_msg;
		}
		return ($sql->err_no);
	}


	function deleteUserLog(){
		$sql = new MySQL_class;
		$sql->Create();
	 	$qry = ' DELETE FROM tblTxnLog WHERE user_id = ' . prepStr($this->user_id);
	 	$sql->Delete($qry);
	 	if($sql->err_no != 0){
			$this->err_no = $sql->err_no;
			$this->err_msg = $sql->err_msg;
		}
		return ($sql->err_no);
	}


	function txnExists($txnid=''){
		$sql = new MySQL_class;
		$sql->Create();
	 	$qry = ' SELECT COUNT(1) FROM tblTxnLog WHERE txn_id = ' . prepStr($txnid) . ' LIMIT 1 ';
	 	$count = $sql->QueryItem($qry);
	 	return ($count);
	}


	function totalUserLog($user_id){
		$sql = new MySQL_class;
		$sql->Create();
	 	$qry = ' SELECT COUNT(1) FROM tblTxnLog WHERE user_id = ' . prepStr($user_id);
	 	$count = $sql->QueryItem($qry);
	 	return ($count);
	}


	function userLog($user_id, $start=0, $count=20, $order='txn_date', $dir='DESC'){
		$sql = new MySQL_class;
		$sql->Create();

		$logs = array();

		$qry = ' SELECT  * '
		     . ' FROM tblTxnLog '
			 . ' WHERE user_id = ' . prepStr($user_id)
		     . ' ORDER BY ' . $order . ' ' . $dir
		     . ' LIMIT ' . $start . ', ' . $count ;

		$sql->Query($qry);
		for($i=0; $i<$sql->rows; $i++){
			$sql->Fetch($i);

			$l = new TxnLog();
			$l->log_id      = $sql->data['log_id'];
			$l->user_id    	= $sql->data['user_id'];
			$l->txn_id      = $sql->data['txn_id'];
			$l->payer_id    = $sql->data['payer_id'];
			$l->subscr_id   = $sql->data['subscr_id'];
			$l->txn_type    = $sql->data['txn_type'];
			$l->item_name   = $sql->data['item_name'];
			$l->item_number = $sql->data['item_number'];
			$l->mc_gross    = $sql->data['mc_gross'];
			$l->mc_fee      = $sql->data['mc_fee'];
			$l->txn_date    = $sql->data['txn_date'];

			$logs[$i]=$l;
		}
		return ($logs);
	}


}

?>