<?php

require_once('../lib/config.php');
require_once('PayPalIPN.class.php');
require_once('User.class.php');
require_once('TxnLog.class.php');
require_once('HtPasswd.class.php');
require_once('Mailer.class.php');
require_once('Smarty.class.php');


// PayPal will send the information through a POST
$paypal_info = $_POST;

$paypal_ipn = new PayPalIPN($paypal_info);
$paypal_ipn->error_email = WEBMASTER_EMAIL;
$paypal_ipn->error_log_file=(SITE_DOC_ROOT . '/paypal/paypal.log');


// We send an identical response back to PayPal for verification
$paypal_ipn->send_response();

// PayPal will tell us whether or not this order is valid.
// This will prevent people from simply running your order script
// manually
if( !$paypal_ipn->is_verified() )
{
	// bad order, someone must have tried to run this script manually
	$paypal_ipn->error_out("Bad order (PayPal says it's invalid)");
}


switch ($paypal_ipn->get_txn_type()){


	case 'subscr_signup':
		$log = new TxnLog();
		$log->user_id = $paypal_info['custom'];
		$log->txn_id = $paypal_info['txn_id'];
		$log->payer_id = $paypal_info['payer_id'];
		$log->subscr_id = $paypal_info['subscr_id'];
		$log->txn_type = $paypal_info['txn_type'];
		$log->item_name = $paypal_info['item_name'];
		$log->item_number = $paypal_info['item_number'];
		$log->txn_date = time();
		$log->insertLog();
		if($log->err_no != 0){
			$paypal_ipn->error_out('Error ' . $log->err_msg);
		}
		$user = new User($paypal_info['custom']);
		// Only change status in not status paid
		if($user->user_status != 5){
			$user->user_status = 2;
			$user->updateUser();
			if($user->err_no != 0){
				$paypal_ipn->error_out('Error ' . $user->err_msg);
			}
		}
	break;



	case 'subscr_payment':

		switch( $paypal_ipn->get_payment_status() ){

			case 'Completed':
				$log = new TxnLog();
				$log->user_id = $paypal_info['custom'];
				$log->txn_id = $paypal_info['txn_id'];
				$log->payer_id = $paypal_info['payer_id'];
				$log->subscr_id = $paypal_info['subscr_id'];
				$log->txn_type = $paypal_info['txn_type'];
				$log->item_name = $paypal_info['item_name'];
				$log->item_number = $paypal_info['item_number'];
				$log->mc_gross = $paypal_info['mc_gross'];
				$log->mc_fee = $paypal_info['mc_fee'];
				$log->txn_date = time();
				$log->insertLog();
				if($log->err_no != 0){
					$paypal_ipn->error_out('Error ' . $log->err_msg);
				}
				$user = new User($paypal_info['custom']);
				if($user->user_id == 0){
					$paypal_ipn->error_out('Unknown Subscription Payment Received. Missing Custom field.');
					exit();
				}
				$user->user_status = 5;
				$user->updateUser();
				if($user->err_no != 0){
					$paypal_ipn->error_out('Error ' . $user->err_msg);
				}
				$ht = new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');
				if(!$ht->isUser($user->user_email)){
					$ht->addUser($user->user_email, $user->user_password);

					$mail = new Mailer();
					$mail->subject = "Welcome to " . SITE_NAME;
					$mail->from    = "Webmaster <" . WEBMASTER_EMAIL . ">";
					$mail->to      = $user->user_firstname . ' ' . $user->user_lastname . '<' . $user->user_email . '>';
					$smarty = new Smarty();
					$smarty->compile_dir = SITE_DOC_ROOT . '/templates_c';
					$smarty->assign('user', $user);
					$mail->msg = $smarty->fetch(SITE_DOC_ROOT . '/templates/welcome.tpl');
					$mail->send();
				}
			break;

			default:
				$paypal_ipn->error_out('Unknown Payment Status ' . $paypal_ipn->get_payment_status());
			break;
		}

	break;


	case 'subscr_cancel':
		$log = new TxnLog();
		$log->user_id = $paypal_info['custom'];
		$log->payer_id = $paypal_info['payer_id'];
		$log->subscr_id = $paypal_info['subscr_id'];
		$log->txn_type = $paypal_info['txn_type'];
		$log->item_name = $paypal_info['item_name'];
		$log->item_number = $paypal_info['item_number'];
		$log->txn_date = time();
		$log->insertLog();
		if($log->err_no != 0){
			$paypal_ipn->error_out('Error ' . $log->err_msg);
		}
		$user = new User($paypal_info['custom']);
		if($user->user_id == 0){
			$paypal_ipn->error_out('Unknown Subscription Cancellation Received. Missing Custom field');
			exit();
		}
		$user->user_status = 3;
		$user->updateUser();
		if($user->err_no != 0){
			$paypal_ipn->error_out('Error ' . $user->err_msg);
		}
	break;


	case 'subscr_eot':
		$log = new TxnLog();
		$log->user_id = $paypal_info['custom'];
		$log->payer_id = $paypal_info['payer_id'];
		$log->subscr_id = $paypal_info['subscr_id'];
		$log->txn_type = $paypal_info['txn_type'];
		$log->item_name = $paypal_info['item_name'];
		$log->item_number = $paypal_info['item_number'];
		$log->txn_date = time();
		$log->insertLog();
		if($log->err_no != 0){
			$paypal_ipn->error_out('Error ' . $log->err_msg);
		}
		$user = new User($paypal_info['custom']);
		if($user->user_id == 0){
			$paypal_ipn->error_out('Unknown Subscription Cancellation Received. Missing Custom field');
			exit();
		}
		$user->user_status = 6;
		$user->updateUser();
		if($user->err_no != 0){
			$paypal_ipn->error_out('Error ' . $user->err_msg);
		}
		$ht = new HtPasswd(SITE_DOC_ROOT . '/members/.htpasswd');
		if($ht->isUser($user->user_email)){
			$ht->deleteUser($user->user_email);
		}
	break;


	default:
		$paypal_ipn->error_out('Unknown Transaction Type: ' . $paypal_ipn->get_txn_type());
	break;

}


